#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <unistd.h>		/* dla libc5 */
#include <sys/io.h>		/* dla glibc */

#include "md5.h"
#include "list.h"
#include "module.h"

#if defined(__i386__) || defined(__alpha__)

#include <sys/io.h>

unsigned short i365_base = 0x03e0;
unsigned short tcic_base = 0x240;
#define I365_IDENT		0x00
#define TCIC_SCTRL		0x06
#define TCIC_SCTRL_RESET	0x80
#define TCIC_ADDR		0x02
#define I365_REG(slot, reg)    (((slot) << 6) | (reg))

static unsigned char
i365_get (unsigned short sock, unsigned short reg)
{
  unsigned char val = I365_REG (sock, reg);
  outb (val, i365_base);
  val = inb (i365_base + 1);
  return val;
}

#endif

struct node *
probe (struct node *devices, int params)
{
  char buf[0x100];
//  struct floppy_drive_struct ds;
  int val, sock, done, i;
  unsigned short old;
  struct node *newdev;
  MD5_CTX context;
  unsigned char digest[16];

  devices = nodecondremove (devices, "BUS", "PCMCIACONT", 1);
#if defined(__i386__) || defined(__alpha__)

  sock = done = 0;
  ioperm (i365_base, 4, 1);
  ioperm (0x80, 1, 1);

  for (; sock < 2; sock++)
  {
    val = i365_get (sock, I365_IDENT);
    switch (val)
    {
    case 0x82:
    case 0x83:
    case 0x84:
    case 0x88:
    case 0x89:
    case 0x8a:
    case 0x8b:
    case 0x8c:
      break;
    default:
      done = 1;
    }
    if (done)
      break;
  }
  if (sock)
  {
    newdev = nodealloc ();
    nodesetprop (newdev, "BUS", "PCMCIACONT");
    nodesetprop (newdev, "CONN", "pcmciacont.1");
    nodesetprop (newdev, "CLASS", "SOCKET");

    nodesetprop (newdev, "DESC",
		 "Generic i82365-compatible PCMCIA controller");
    nodesetprop (newdev, "DRIVER", "i82365");

    MD5Init (&context);
    MD5UpdateS (&context, nodegetprop (newdev, "DESC"));
    MD5Final (digest, &context);

    sprintf (buf,
	     "%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x",
	     digest[0], digest[1], digest[2], digest[3], digest[4],
	     digest[5], digest[6], digest[7], digest[8], digest[9],
	     digest[10], digest[11], digest[12], digest[13],
	     digest[14], digest[15]);

    nodesetprop (newdev, "MD5_ID", buf);

    devices = nodeadd (devices, newdev);
  }
  ioperm (tcic_base, 16, 1);
  ioperm (0x80, 1, 1);

  /* Anything there?? */
  for (i = 0; i < 0x10; i += 2)
    if (inw (tcic_base + i) == 0xffff)
      return devices;

  /* Try to reset the chip */
  outw (TCIC_SCTRL_RESET, tcic_base + TCIC_SCTRL);
  outw (0, tcic_base + TCIC_SCTRL);

  /* Can we set the addr register? */
  old = inw (tcic_base + TCIC_ADDR);
  outw (0, tcic_base + TCIC_ADDR);
  if (inw (tcic_base + TCIC_ADDR) != 0)
  {
    outw (old, tcic_base + TCIC_ADDR);
    return devices;
  }

  outw (0xc3a5, tcic_base + TCIC_ADDR);
  if (inw (tcic_base + TCIC_ADDR) != 0xc3a5)
    return devices;

  newdev = nodealloc ();
  nodesetprop (newdev, "BUS", "PCMCIACONT");
  nodesetprop (newdev, "CONN", "pcmciacont.2");
  nodesetprop (newdev, "CLASS", "SOCKET");

  nodesetprop (newdev, "DESC", "Generic TCIC-2 PCMCIA controller");
  nodesetprop (newdev, "DRIVER", "tcic");

  MD5Init (&context);
  MD5UpdateS (&context, nodegetprop (newdev, "DESC"));
  MD5Final (digest, &context);

  sprintf (buf,
	   "%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x",
	   digest[0], digest[1], digest[2], digest[3], digest[4],
	   digest[5], digest[6], digest[7], digest[8], digest[9],
	   digest[10], digest[11], digest[12], digest[13],
	   digest[14], digest[15]);

  nodesetprop (newdev, "MD5_ID", buf);

  devices = nodeadd (devices, newdev);
#endif

  return devices;
}

#ifdef HAPS_MODULES
struct modulehandler *
_init_module (void)
{
  struct modulehandler *mh;
  mh = malloc (sizeof (*mh));
  mh->probe = probe;
  return mh;
}
#endif
