// Based on HWSETUP by Klaus Knopper <knopper@knopper.net>

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <errno.h>
#include <signal.h>
#include <time.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <sys/stat.h>
#include <dlfcn.h>

#include "haps.h"
#include "module.h"
#include "list.h"
#include "probe.h"
#include "md5.h"


/*
char *getclassname(int class)
{
  return class==CLASS_UNSPEC?"UNSPEC":  class==CLASS_OTHER?"OTHER":
             class==CLASS_NETWORK?"NETWORK":class==CLASS_SCSI?"SCSI":
             class==CLASS_VIDEO?"VIDEO":    class==CLASS_AUDIO?"AUDIO":
             class==CLASS_MOUSE?"MOUSE":    class==CLASS_MODEM?"MODEM":
             class==CLASS_CDROM?"CDROM":    class==CLASS_TAPE?"TAPE":
             class==CLASS_FLOPPY?"FLOPPY":  class==CLASS_SCANNER?"SCANNER":
             class==CLASS_HD?"HD":          class==CLASS_RAID?"RAID":
             class==CLASS_PRINTER?"PRINTER":class==CLASS_CAPTURE?"CAPTURE":
	     class==CLASS_USB?"USB":        class==CLASS_MONITOR?"MONITOR":
             class==CLASS_KEYBOARD?"KEYBOARD":NULL;
}

char *getbusname(int bus)
{
  return bus==BUS_OTHER?"OTHER":  bus==BUS_PCI? "PCI":
             bus==BUS_SBUS?"SBUS":    bus==BUS_PSAUX?"PSAUX":
	     bus==BUS_SERIAL?"SERIAL":bus==BUS_PARALLEL?"PARALLEL":
	     bus==BUS_SCSI?"SCSI":    bus==BUS_IDE?"IDE":
	     bus==BUS_DDC?"DDC":      bus==BUS_USB?"USB":
             bus==BUS_KEYBOARD?"KEYBOARD":
             bus==BUS_ISAPNP?"ISAPNP":NULL;
return NULL;
}
*/

struct node *probe(char *type,struct node *devices)
{
//  struct node *newdev=NULL;
//  struct node *curdev;
//  char biosname[0x100];
//  char *val1,*val2;
//  int i;
//  struct xinfo *xi;
//  struct device **currentDevs, *d;
  void *dh;
  struct modulehandler *mh;
  struct modulehandler *(*func)(void);
  char buf[0x100];

  sprintf(buf,"%s/%s.so",HAPS_MODULES_PATH,type);

  if((dh = dlopen(buf, RTLD_LAZY)) == NULL)
  {
    fprintf(stderr, "%s\n", dlerror());
    return devices;
  }

  if((func = dlsym(dh, "_init_module")) == NULL)
  {
    fprintf(stderr, "%s\n", dlerror());
    return devices;
  }

  mh = func();
  devices=mh->probe(devices,0);

  free(mh);
  dlclose(dh);
  
/*
      if (d->class==CLASS_VIDEO)
      {
        if ((xi=getxinfo(d)))
        {
          if(*xi->xserver) nodesetprop(newdev,"XSERVER",xi->xserver);
          if(*xi->xmodule) nodesetprop(newdev,"XMODULE",xi->xmodule);
          if(*xi->xopts) nodesetprop(newdev,"XOPTIONS",xi->xopts);
          if(*xi->xdesc) nodesetprop(newdev,"XDESC",xi->xdesc);
  
          MD5UpdateS(&context,xi->xserver);
          MD5UpdateS(&context,xi->xmodule);
          MD5UpdateS(&context,xi->xopts);
          MD5UpdateS(&context,xi->xdesc);

        }
      }
  };
  
*/

  return devices;
}
